#pragma once

#include "logger/manager.h"

// macro to notify Events
#ifdef _MSC_VER

#define _event(type, file, line, szfmt, ...)     ::get_instance<debug_logger_manager_t>()->notify(type, file, line, format(szfmt, __VA_ARGS__))

#define _debug(szfmt, ...)		                 _event(debug::logger::event::type::DBG_MESSAGE, __FILE__, __LINE__, szfmt, __VA_ARGS__);
#define _warning(szfmt, ...)	                 _event(debug::logger::event::type::DBG_WARNING, __FILE__, __LINE__, szfmt, __VA_ARGS__);
#define _error(szfmt, ...)		                 _event(debug::logger::event::type::DBG_ERROR, __FILE__, __LINE__, szfmt, __VA_ARGS__);
#define _critical(szfmt, ...)	                 _event(debug::logger::event::type::DBG_CRITICAL, __FILE__, __LINE__, szfmt, __VA_ARGS__);

#else

#define _event(type, file, line, szfmt, ...)	::get_instance<debug_logger_manager_t>()->notify(type, file, line, format(szfmt __VA_OPT__(,) __VA_ARGS__))

#define _debug(szfmt, ...)		                 _event(debug::logger::event::type::DBG_MESSAGE, __FILE__, __LINE__, szfmt __VA_OPT__(,) __VA_ARGS__);
#define _warning(szfmt, ...)	                 _event(debug::logger::event::type::DBG_WARNING, __FILE__, __LINE__, szfmt __VA_OPT__(,) __VA_ARGS__);
#define _error(szfmt, ...)		                 _event(debug::logger::event::type::DBG_ERROR, __FILE__, __LINE__, szfmt __VA_OPT__(,) __VA_ARGS__);
#define _critical(szfmt, ...)	                 _event(debug::logger::event::type::DBG_CRITICAL, __FILE__, __LINE__, szfmt __VA_OPT__(,) __VA_ARGS__);

#endif