#pragma once

#include "../../strings/format.h"
#include "../../strings/fileparts.h"

#include "base.h"

#include <string>
#include <mutex>

#ifdef _WIN32
#include <Windows.h>
#endif

namespace debug::logger
{

#ifdef _WIN32

	/* windows debugger logger class */
	class windbg : public base
	{
	public:
		virtual void notify(const event& e) const override
		{
            std::lock_guard<std::mutex> lock(this->m_lock);

            auto filename_nodir = split_file_path(e.get_filename()).file;

			std::string str = "[" + e.get_string_time() + "]\t" + e.get_string_type() + "\t" + filename_nodir + "\t" + e.get_message() + std::string("\r\n");

			OutputDebugStringA(str.c_str());
		}

	private:
		mutable std::mutex m_lock;
	};

#endif
};